//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <stdio.h>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <CheckLst.hpp>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TOpenDialog *OpenDialogSMC;
        TMainMenu *MainMenu;
        TMenuItem *File1;
        TMenuItem *Open1;
        TPaintBox *PaintBox1;
        TButton *ButtonLeft;
        TButton *ButtonRight;
        TButton *ButtonUp;
        TButton *ButtonDown;
        TComboBox *ComboBoxTile;
        TComboBox *ComboBoxBack;
        TMenuItem *Save1;
        TPanel *Panel1;
        TComboBox *ComboBoxFg;
        TComboBox *ComboBoxGg;
        TComboBox *ComboBoxOb;
        TPopupMenu *PopupMenu1;
        TMenuItem *Starthere1;
        TMenuItem *Guardhere1;
        TMenuItem *Deleteguard1;
        TMenuItem *Guardtype1;
        TMenuItem *Flipstart1;
        TMenuItem *Flipguard1;
        TMenuItem *N1;
        TMenuItem *Guardskill1;
        TMenuItem *N2;
        TMenuItem *Roomlinks1;
        TComboBox *ComboBoxMod;
        TEdit *EditRm;
        TEdit *EditPs;
        TCheckBox *CheckBoxNx;
        TStatusBar *StatusBar1;
        TCheckListBox *CheckListBoxFlags;
        TMenuItem *Export1;
        TMenuItem *Import1;
        TOpenDialog *OpenDialogImport;
        TSaveDialog *SaveDialogExport;
        TLabel *Label1;
        TMenuItem *Mode1;
        TMenuItem *Automatic1;
        TMenuItem *Manual1;
        TMenuItem *N3;
        TMenuItem *Labels1;
        TMenuItem *Level1;
        TMenuItem *Clearallrooms1;
        TMenuItem *Clearthisroom1;
        TMenuItem *Jumptoroom1;
        TMenuItem *Changetype1;
        TMenuItem *N2x1;
        TMenuItem *Guards1;
        TMenuItem *Hitpoints1;
        TMenuItem *Palettes1;
        TMenuItem *Settings1;
        TMenuItem *Changemusic1;
        TMenuItem *Clearallroomsandtiles1;
        TMenuItem *Graphics1;
        TMenuItem *Editenvpal1;
        TMenuItem *Editspritespal1;
        TMenuItem *Editlevelgr;
        TMenuItem *Layer1;
        TMenuItem *Layer2;
        TMenuItem *Layer3;
        TEdit *EditAnimGroup;
        TMenuItem *Size1;
        TMenuItem *N1x1;
        TMenuItem *N3x1;
        TMenuItem *N4x1;
        TMenuItem *Room1;
        TMenuItem *Copyroom1;
        TMenuItem *Pasteroom1;
        TMenuItem *Swaproom1;
        TMenuItem *Swappositions1;
        TMenuItem *Swapdetails1;
        TMenuItem *Swaptransparent1;
        TMenuItem *Floorsandwalls1;
        void __fastcall Open1Click(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall PaintBox1Paint(TObject *Sender);
        void __fastcall ButtonLeftClick(TObject *Sender);
        void __fastcall ButtonRightClick(TObject *Sender);
        void __fastcall ButtonUpClick(TObject *Sender);
        void __fastcall ButtonDownClick(TObject *Sender);
        void __fastcall PaintBox1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ComboBoxTileDrawItem(TWinControl *Control,
          int Index, TRect &Rect, TOwnerDrawState State);
        void __fastcall ComboBoxTileChange(TObject *Sender);
        void __fastcall ComboBoxBackChange(TObject *Sender);
        void __fastcall ComboBoxBackDrawItem(TWinControl *Control,
          int Index, TRect &Rect, TOwnerDrawState State);
        void __fastcall Save1Click(TObject *Sender);
        void __fastcall ComboBoxFgDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall ComboBoxGgDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall ComboBoxFgChange(TObject *Sender);
        void __fastcall ComboBoxGgChange(TObject *Sender);
        void __fastcall ComboBoxObChange(TObject *Sender);
        void __fastcall Starthere1Click(TObject *Sender);
        void __fastcall Guardhere1Click(TObject *Sender);
        void __fastcall Deleteguard1Click(TObject *Sender);
        void __fastcall Flipstart1Click(TObject *Sender);
        void __fastcall Flipguard1Click(TObject *Sender);
        void __fastcall Guardtype1Click(TObject *Sender);
        void __fastcall Guardskill1Click(TObject *Sender);
        void __fastcall Roomlinks1Click(TObject *Sender);
        void __fastcall ComboBoxModChange(TObject *Sender);
        void __fastcall EditRmChange(TObject *Sender);
        void __fastcall EditPsChange(TObject *Sender);
        void __fastcall CheckBoxNxClick(TObject *Sender);
        void __fastcall CheckListBoxFlagsClick(TObject *Sender);
        void __fastcall Export1Click(TObject *Sender);
        void __fastcall Import1Click(TObject *Sender);
        void __fastcall Automatic1Click(TObject *Sender);
        void __fastcall Manual1Click(TObject *Sender);
        void __fastcall Labels1Click(TObject *Sender);
        void __fastcall Clearallrooms1Click(TObject *Sender);
        void __fastcall Clearthisroom1Click(TObject *Sender);
        void __fastcall Jumptoroom1Click(TObject *Sender);
        void __fastcall Changetype1Click(TObject *Sender);
        void __fastcall N2x1Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Hitpoints1Click(TObject *Sender);
        void __fastcall Palettes1Click(TObject *Sender);
        void __fastcall Settings1Click(TObject *Sender);
        void __fastcall Changemusic1Click(TObject *Sender);
        void __fastcall Clearallroomsandtiles1Click(TObject *Sender);
        void __fastcall Editenvpal1Click(TObject *Sender);
        void __fastcall Editspritespal1Click(TObject *Sender);
        void __fastcall Layer1Click(TObject *Sender);
        void __fastcall Layer2Click(TObject *Sender);
        void __fastcall Layer3Click(TObject *Sender);
        void __fastcall EditAnimGroupChange(TObject *Sender);
        void __fastcall N1x1Click(TObject *Sender);
        void __fastcall N3x1Click(TObject *Sender);
        void __fastcall N4x1Click(TObject *Sender);
        void __fastcall Swappositions1Click(TObject *Sender);
        void __fastcall Swapdetails1Click(TObject *Sender);
        void __fastcall Swaptransparent1Click(TObject *Sender);
        void __fastcall Copyroom1Click(TObject *Sender);
        void __fastcall Pasteroom1Click(TObject *Sender);
        void __fastcall Floorsandwalls1Click(TObject *Sender);
private:	// User declarations
void open_file(AnsiString filename);
void RealignStuff();
int scale;
public:		// User declarations
int /*level,rm,*/lasti,lastj;
void DrawRoom();
bool open;
AnsiString file;
void GetTile(int);
int Select(const char*[],int,int,AnsiString);
void GetMod(int);
void SetMod(int);
void DoAuto(int);
TButton* (sidebtn[10+3+1]);
void PlaceSidebtn();
Graphics::TBitmap* kep;
bool amode;

void ClearAll(bool);
void __fastcall SideClick(TObject *Sender);
TSMC smc;
void RedrawAll();
bool room_clipboard_notempty;
TRoom room_clipboard;
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
//#define SMCHD 0x200
int InputNum(AnsiString Caption,AnsiString Prompt,int Default);

#endif

