//---------------------------------------------------------------------------

#ifndef LevelGraphicsEditH
#define LevelGraphicsEditH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Grids.hpp>
#include "smc.h"
//---------------------------------------------------------------------------
class TLevelGraphicsEditForm : public TForm
{
__published:	// IDE-managed Components
        TPageControl *PageControl1;
        TTabSheet *TabSheetGraphicsTiles;
        TTabSheet *TabSheetLevelTiles;
        TDrawGrid *DrawGridBlock;
        TComboBox *ComboBoxBlock;
        TDrawGrid *DrawGridTiles;
        TCheckBox *CheckBoxFlipX;
        TCheckBox *CheckBoxFlipY;
        TEdit *EditPalIndex;
        TUpDown *UpDownPalIndex;
        TLabel *LabelPalette;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall ComboBoxBlockDrawItem(TWinControl *Control,
          int Index, TRect &Rect, TOwnerDrawState State);
        void __fastcall DrawGridTilesSelectCell(TObject *Sender, int ACol,
          int ARow, bool &CanSelect);
        void __fastcall CheckBoxFlipXClick(TObject *Sender);
        void __fastcall CheckBoxFlipYClick(TObject *Sender);
        void __fastcall ComboBoxBlockChange(TObject *Sender);
        void __fastcall DrawGridBlockDrawCell(TObject *Sender, int ACol,
          int ARow, TRect &Rect, TGridDrawState State);
        void __fastcall DrawGridTilesDrawCell(TObject *Sender, int ACol,
          int ARow, TRect &Rect, TGridDrawState State);
        void __fastcall DrawGridBlockSelectCell(TObject *Sender, int ACol,
          int ARow, bool &CanSelect);
        void __fastcall UpDownPalIndexClick(TObject *Sender,
          TUDBtnType Button);
private:	// User declarations
        TSMC* smc;
        int wh,hh,si,nt;
        unsigned __int16* block;
        unsigned char* tile;
        unsigned char r0;
        int ix;
        int selrow,selcol; unsigned __int16* currblock;
public:		// User declarations
        __fastcall TLevelGraphicsEditForm(TComponent* Owner);
        void edit_graphics(TSMC* smc_,int wh_,int hh_,int si_,unsigned __int16* block_,unsigned char* tile_,unsigned char r0_,int nt_);
};
//---------------------------------------------------------------------------
//extern PACKAGE TLevelGraphicsEditForm *LevelGraphicsEditForm;
//---------------------------------------------------------------------------
#endif
