//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "smc.h"
#include "Main.h"
//#include "LevelGraphicsEdit.h"
//#include <Clipbrd.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
    room_clipboard_notempty = false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Open1Click(TObject *Sender)
{
 if(OpenDialogSMC->Execute()){
//    int lv;
/*    AnsiString s=InputBox("Szint","Szint","0");
    try{level=StrToInt(s);}catch(...){level=0;}*/
    open_file(/*file*/OpenDialogSMC->FileName);
 }
}
//---------------------------------------------------------------------------

void TMainForm::open_file(AnsiString filename){
    OpenDialogSMC->FileName = filename;
    file=filename;
    bool oldopen=open;
    open=false;
    if(!smc.opensmc(file)) { /*open=true;*/ ShowMessage("Can't open file \""+filename+"\"."); return; }
    int nlevel=Select(levels,COUNT(levels),-1,"Select level");
    if(nlevel<0||nlevel>26){ open=oldopen; return; }
    smc.curr_level=nlevel;
    room_clipboard_notempty = false;
    smc.openlevel();
    //smc.openenv(smc.ltype=*((char*)smc.ms_smc->Memory+0x36EE+SMCHD+level));
    //smc.otype=*((char*)smc.ms_smc->Memory+0xED08+SMCHD+level);
    smc.curr_rm=smc.level.start_rm;
    open=true;
    kep->Width=240;
    kep->Height=192;
    DrawRoom();
//    PaintBox1->Invalidate();
//    PaintBox1Paint(NULL);
    ComboBoxTile->Enabled=true;
    ComboBoxBack->Enabled=true;
    Level1->Enabled=true;
    PaintBox1->Enabled=true;
    Guards1->Enabled=true;
    Graphics1->Enabled=true;
    EditAnimGroup->Enabled=true;
    ComboBoxFg->Enabled=true;
    ComboBoxGg->Enabled=true;
    ComboBoxOb->Enabled=true;
    CheckListBoxFlags->Enabled=true;
    ComboBoxMod->Enabled=true;
    EditRm->Enabled=true;
    EditPs->Enabled=true;
    CheckBoxNx->Enabled=true;
    Room1->Enabled=true;
    Caption=file;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
 amode=true; scale=1;
 kep=new Graphics::TBitmap;
 kep->Width=240;
 kep->Height=192;
 Level1->Enabled=false;
 Guards1->Enabled=false;
 Graphics1->Enabled=false;
 Room1->Enabled=false;
 AnsiString s; int i;
 for(i=0;i<256;i++){
    s=IntToHex(i,2);
    ComboBoxTile->Items->Add(s);
    ComboBoxBack->Items->Add(s);
    ComboBoxFg->Items->Add(s);
    ComboBoxGg->Items->Add(s);
    ComboBoxMod->Items->Add(s);
 }
 for(i=0;i<COUNT(ob);i++){
    ComboBoxOb->Items->Add(ob[i]);
 }
 for(i=0;i<14;i++){
    sidebtn[i]=new TButton(Application);
    sidebtn[i]->Parent=this;
    sidebtn[i]->Tag=i;
    sidebtn[i]->OnClick=SideClick;
 }
 open=false;
 Automatic1Click(Sender);
 PlaceSidebtn();
 if(ParamCount()>=1){
    open_file(ParamStr(1));
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
 delete kep;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PaintBox1Paint(TObject *Sender)
{
   PaintBox1->Width=kep->Width*scale;
   PaintBox1->Height=kep->Height*scale;
   if(scale==1){
      PaintBox1->Canvas->Draw(0,0,kep);
   }else{
      PaintBox1->Canvas->StretchDraw(TRect(0,0,PaintBox1->Width,PaintBox1->Height),kep);
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonLeftClick(TObject *Sender)
{
 int rm2=smc.level.rm_links[smc.curr_rm][0];
 if(rm2<=23){ smc.curr_rm=rm2; smc.clearsel(); DrawRoom(); }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonRightClick(TObject *Sender)
{
 int rm2=smc.level.rm_links[smc.curr_rm][1];
 if(rm2<=23){ smc.curr_rm=rm2; smc.clearsel(); DrawRoom(); }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonUpClick(TObject *Sender)
{
 int rm2=smc.level.rm_links[smc.curr_rm][2];
 if(rm2<=23){ smc.curr_rm=rm2; smc.clearsel(); DrawRoom(); }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ButtonDownClick(TObject *Sender)
{
 int rm2=smc.level.rm_links[smc.curr_rm][3];
 if(rm2<=23){ smc.curr_rm=rm2; smc.clearsel(); DrawRoom(); }
}
//---------------------------------------------------------------------------
void TMainForm::DrawRoom(){
   smc.drawroom(kep);
   ButtonLeft->Enabled=smc.level.rm_links[smc.curr_rm][0]<24;
   ButtonRight->Enabled=smc.level.rm_links[smc.curr_rm][1]<24;
   ButtonUp->Enabled=smc.level.rm_links[smc.curr_rm][2]<24;
   ButtonDown->Enabled=smc.level.rm_links[smc.curr_rm][3]<24;
   ButtonLeft->Caption=smc.level.rm_links[smc.curr_rm][0];
   ButtonRight->Caption=smc.level.rm_links[smc.curr_rm][1];
   ButtonUp->Caption=smc.level.rm_links[smc.curr_rm][2];
   ButtonDown->Caption=smc.level.rm_links[smc.curr_rm][3];
   PaintBox1->OnPaint(NULL);
   AnsiString s;
   s.printf("%s, room %d, tile %d",levels[smc.curr_level],smc.curr_rm,lasti*10+lastj);
   StatusBar1->SimpleText=s;
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::PaintBox1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   if(!open) return;
   int i=Y/(64*scale),j=X/(24*scale);
   lasti=i; lastj=j;
   if(Shift.Contains(ssCtrl)){
      smc.sel[i][j]^=true;
   }else{
      smc.clearsel();
      smc.sel[i][j]=true;
   }
   ComboBoxTile->ItemIndex=smc.level.fg[smc.curr_rm][i][j];
   int bg=smc.level.bg[smc.curr_rm][i][j];
   ComboBoxBack->ItemIndex=bg;
   ComboBoxMod->ItemIndex=smc.level.md[smc.curr_rm][i][j];
   GetTile(smc.level.fg[smc.curr_rm][i][j]);
   GetMod(smc.level.md[smc.curr_rm][i][j]);
   ComboBoxFg->ItemIndex=smc.level.block_fg[smc.level.fg[smc.curr_rm][i][j]];
   ComboBoxGg->ItemIndex=smc.level.block_gg[smc.level.fg[smc.curr_rm][i][j]];
   ComboBoxOb->ItemIndex=smc.level.block_ob[smc.level.fg[smc.curr_rm][i][j]];
   EditAnimGroup->Text=IntToStr(smc.get_bganim(bg));
   DrawRoom();
}
//---------------------------------------------------------------------------
void TMainForm::GetTile(int ix){
   ComboBoxFg->ItemIndex=smc.level.block_fg[ix];
   ComboBoxGg->ItemIndex=smc.level.block_gg[ix];
   ComboBoxOb->ItemIndex=smc.level.block_ob[ix];
   //unsigned char fl=smc.level.block_fl[ix];
   unsigned char fl=smc.get_block_fl(ix);
   for(int i=0;i</*8*/2;i++){
      CheckListBoxFlags->Checked[i]=(fl>>i)&1;
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBoxTileDrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
 if(!open) return;
 bool sel=State.Contains(odSelected);
 Graphics::TBitmap* kiskep=new Graphics::TBitmap;
 kiskep->Width=48; kiskep->Height=64;
 kiskep->Canvas->Brush->Color=smc.pal[0];
 kiskep->Canvas->FillRect(TRect(0,0,48,64));
 smc.drawblock(kiskep,0,0,smc.level.block_fg[Index],6,8,32,smc.fgblock,smc.fgtile,0x60,sel);
 smc.drawanobj(kiskep,0,0,smc.level.block_ob[Index],sel);
 smc.drawblock(kiskep,0,0,smc.level.block_gg[Index],3,8,32,smc.ggblock,smc.ggtile,0x20,sel);
 kiskep->Canvas->Brush->Color=clWhite;
 kiskep->Canvas->Pen->Color=clBlack;
 if(smc.want_label){
    int x=smc.level.block_ob[Index];
    if(x>0&&x<COUNT(ob)) kiskep->Canvas->TextOutA(0,0,ob[x]);
 }
 ComboBoxTile->Canvas->Draw(Rect.left,Rect.top,kiskep);
 ComboBoxTile->Canvas->TextOutA(48+Rect.left,Rect.top,IntToHex(Index,2));
 delete kiskep;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBoxTileChange(TObject *Sender)
{
   if(!open) return;
   int i,j;
   for(i=0;i<3;i++) for(j=0;j<10;j++) if(smc.sel[i][j]) smc.level.fg[smc.curr_rm][i][j]=ComboBoxTile->ItemIndex;
   DrawRoom();
   GetTile(ComboBoxTile->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBoxBackChange(TObject *Sender)
{
   if(!open) return;
   int i,j;
   for(i=0;i<3;i++) for(j=0;j<10;j++) if(smc.sel[i][j]) smc.level.bg[smc.curr_rm][i][j]=ComboBoxBack->ItemIndex;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBoxBackDrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
 if(!open) return;
 Graphics::TBitmap* kiskep=new Graphics::TBitmap;
 kiskep->Width=24; kiskep->Height=64;
 kiskep->Canvas->Brush->Color=smc.pal[0];
 kiskep->Canvas->FillRect(TRect(0,0,24,64));
 smc.drawblock(kiskep,0,0,Index,3,8,16,smc.bgblock,smc.bgtile,0x00,State.Contains(odSelected));
 ComboBoxBack->Canvas->Draw(Rect.left,Rect.top,kiskep);
 ComboBoxBack->Canvas->TextOutA(24+Rect.left,Rect.top,IntToHex(Index,2));
 delete kiskep;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Save1Click(TObject *Sender)
{
 if(!open) return;
 smc.savelevel();
 smc.saveenv();
 smc.savesmc(file);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBoxFgDrawItem(TWinControl *Control, int Index,
      TRect &Rect, TOwnerDrawState State)
{
 if(!open) return;
 Graphics::TBitmap* kiskep=new Graphics::TBitmap;
 kiskep->Width=48; kiskep->Height=64;
 kiskep->Canvas->Brush->Color=smc.pal[0];
 kiskep->Canvas->FillRect(TRect(0,0,48,64));
 smc.drawblock(kiskep,0,0,Index,6,8,32,smc.fgblock,smc.fgtile,0x60,State.Contains(odSelected));
 ComboBoxFg->Canvas->Draw(Rect.left,Rect.top,kiskep);
 ComboBoxFg->Canvas->TextOutA(48+Rect.left,Rect.top,IntToHex(Index,2));
 delete kiskep;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBoxGgDrawItem(TWinControl *Control, int Index,
      TRect &Rect, TOwnerDrawState State)
{
 if(!open) return;
 Graphics::TBitmap* kiskep=new Graphics::TBitmap;
 kiskep->Width=24; kiskep->Height=64;
 kiskep->Canvas->Brush->Color=smc.pal[0];
 kiskep->Canvas->FillRect(TRect(0,0,24,64));
 smc.drawblock(kiskep,0,0,Index,3,8,32,smc.ggblock,smc.ggtile,0x20,State.Contains(odSelected));
 ComboBoxGg->Canvas->Draw(Rect.left,Rect.top,kiskep);
 ComboBoxGg->Canvas->TextOutA(24+Rect.left,Rect.top,IntToHex(Index,2));
 delete kiskep;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBoxFgChange(TObject *Sender)
{
   if(!open) return;
   if(amode) return DoAuto('f');
   smc.level.block_fg[ComboBoxTile->ItemIndex]=ComboBoxFg->ItemIndex;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBoxGgChange(TObject *Sender)
{
   if(!open) return;
   if(amode) return DoAuto('g');
   smc.level.block_gg[ComboBoxTile->ItemIndex]=ComboBoxGg->ItemIndex;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBoxObChange(TObject *Sender)
{
   if(!open) return;
   if(amode) return DoAuto('o');
   smc.level.block_ob[ComboBoxTile->ItemIndex]=ComboBoxOb->ItemIndex;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Starthere1Click(TObject *Sender)
{
   smc.level.start_rm=smc.curr_rm;
   smc.level.start_ps=lasti*10+lastj;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Guardhere1Click(TObject *Sender)
{
   smc.level.guard_ps[smc.curr_rm]=lasti*10+lastj;
   int x=smc.level.guard_tp[smc.curr_rm]&0x7F;
   if(x<2 || x>19) smc.level.guard_tp[smc.curr_rm]=9;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Deleteguard1Click(TObject *Sender)
{
   smc.level.guard_ps[smc.curr_rm]=255;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Flipstart1Click(TObject *Sender)
{
   smc.level.start_dr=smc.level.start_dr?0:255;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Flipguard1Click(TObject *Sender)
{
   smc.level.guard_tp[smc.curr_rm]^=0x80;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Guardtype1Click(TObject *Sender)
{
   int x=smc.level.guard_tp[smc.curr_rm],tp=x&0x7F;
/*   AnsiString s=InputBox("Guard","Guard","0");
   try{x=StrToInt(s);}catch(...){x=0;}*/
   tp=Select(gu,COUNT(gu),tp,"Select guard type");
   x=x&0x80|tp;
   smc.level.guard_tp[smc.curr_rm]=x;
   DrawRoom();
}
//---------------------------------------------------------------------------
int TMainForm::Select(const char* list[],int n,int def,AnsiString s){
   int i;
   TForm* dform; TListBox* dlist; TButton* dok,*dcan;
   dform=new TForm(Application);
   dlist=new TListBox(Application);
   dok=new TButton(Application);
   dcan=new TButton(Application);
   dlist->Parent=dform;
   dok->Parent=dform;
   dcan->Parent=dform;
   dform->Caption=s;
   for(i=0;i<n;i++) dlist->Items->Add(list[i]);
   dlist->ItemIndex=def;
   dlist->Height=(dlist->ItemHeight+1)*n;
   dok->Left=0; dok->Top=dlist->Height; dok->Caption="OK";
   dok->ModalResult=mrOk; dok->Default=true; dok->Width=dlist->Width/2;
   dcan->Left=dlist->Width/2; dcan->Top=dlist->Height; dcan->Caption="Cancel";
   dcan->ModalResult=mrCancel; dcan->Cancel=true; dcan->Width=dlist->Width/2;
   dform->AutoSize=true;
   dform->Position=poMainFormCenter;
   dform->BorderIcons=TBorderIcons();
   dform->BorderStyle=bsSingle;
   if(dform->ShowModal()==mrOk){
      i=dlist->ItemIndex;
   }else{
      i=def;
   }
   delete dlist;
   delete dok;
   delete dcan;
   delete dform;
   return i;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Guardskill1Click(TObject *Sender)
{
   int x=smc.level.guard_sk[smc.curr_rm];
/*   AnsiString s=InputBox("skill","skill",IntToStr(x));
   try{x=StrToInt(s);}catch(...){}*/
   x=InputNum("skill","skill",x);
   smc.level.guard_sk[smc.curr_rm]=x;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Roomlinks1Click(TObject *Sender)
{
   TForm* dform; TButton* dok,*dcan; TEdit* dl,*dr,*du,*dd;
   dform=new TForm(Application);
   dform->Caption="Room links";
   dform->Width=150; dform->Height=200;
   dok=new TButton(Application); dok->Parent=dform; dok->Caption="OK"; dok->Width=50;
   dok->Left=10; dok->Top=120; dok->Default=true; dok->ModalResult=mrOk;
   dcan=new TButton(Application); dcan->Parent=dform; dcan->Caption="Cancel"; dcan->Width=50;
   dcan->Left=60; dcan->Top=120; dcan->Cancel=true; dcan->ModalResult=mrCancel;
   dl=new TEdit(Application); dl->Parent=dform; dl->Left=10; dl->Top=50; dl->Width=30;
   dr=new TEdit(Application); dr->Parent=dform; dr->Left=90; dr->Top=50; dr->Width=30;
   du=new TEdit(Application); du->Parent=dform; du->Left=50; du->Top=10; du->Width=30;
   dd=new TEdit(Application); dd->Parent=dform; dd->Left=50; dd->Top=90; dd->Width=30;
   dform->Position=poMainFormCenter;
   dform->BorderIcons=TBorderIcons();
   dform->BorderStyle=bsSingle;
   dl->Text=IntToStr(smc.level.rm_links[smc.curr_rm][0]);
   dr->Text=IntToStr(smc.level.rm_links[smc.curr_rm][1]);
   du->Text=IntToStr(smc.level.rm_links[smc.curr_rm][2]);
   dd->Text=IntToStr(smc.level.rm_links[smc.curr_rm][3]);
   if(dform->ShowModal()==mrOk){
      smc.level.rm_links[smc.curr_rm][0]=StrToInt(dl->Text);
      smc.level.rm_links[smc.curr_rm][1]=StrToInt(dr->Text);
      smc.level.rm_links[smc.curr_rm][2]=StrToInt(du->Text);
      smc.level.rm_links[smc.curr_rm][3]=StrToInt(dd->Text);
      DrawRoom();
   }
   delete dok; delete dcan; delete dl; delete dr; delete du; delete dd;
   delete dform;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ComboBoxModChange(TObject *Sender)
{
   if(!open) return;
   int i,j;
   for(i=0;i<3;i++) for(j=0;j<10;j++) if(smc.sel[i][j]) smc.level.md[smc.curr_rm][i][j]=ComboBoxMod->ItemIndex;
   GetMod(ComboBoxMod->ItemIndex);
   DrawRoom();
}
//---------------------------------------------------------------------------
void TMainForm::GetMod(int ix){
   unsigned char ch1=smc.level.door1[ix],ch2=smc.level.door2[ix];
   int rm=(ch1&0x60)>>5|(ch2&0xE0)>>3;
   int ti=ch1&0x1F;
   bool nx=ch1>>7;
   open=false;
   EditRm->Text=IntToStr(rm);
   EditPs->Text=IntToStr(ti);
   CheckBoxNx->Checked=nx;
   open=true;
}
//---------------------------------------------------------------------------
void TMainForm::SetMod(int ix){
   unsigned char ch1,ch2;
   try{
      int rm=StrToInt(EditRm->Text);
      int ti=StrToInt(EditPs->Text);
      bool nx=CheckBoxNx->Checked;
      ch1=ti&0x1F|(rm&3)<<5|nx<<7;
      ch2=(rm&0x1C)<<3;
      smc.level.door1[ix]=ch1; smc.level.door2[ix]=ch2;
   }catch(...){GetMod(ix);}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::EditRmChange(TObject *Sender)
{
   if(open) SetMod(ComboBoxMod->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::EditPsChange(TObject *Sender)
{
   if(open) SetMod(ComboBoxMod->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CheckBoxNxClick(TObject *Sender)
{
   if(open) SetMod(ComboBoxMod->ItemIndex);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CheckListBoxFlagsClick(TObject *Sender)
{
   if(!open) return;
   if(amode) return DoAuto('F');
   unsigned char fl=0;
   for(int i=0;i</*8*/2;i++){
      if(CheckListBoxFlags->Checked[i]) fl|=1<<i;
   }
   //smc.level.block_fl[ComboBoxTile->ItemIndex]=fl;
   smc.set_block_fl(ComboBoxTile->ItemIndex,fl);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Export1Click(TObject *Sender)
{
 if(!open) return;
 if(SaveDialogExport->Execute()){
    TMemoryStream* ms=new TMemoryStream;
    ms->Write(&smc.level,sizeof(TLevel));
    ms->SaveToFile(SaveDialogExport->FileName);
    delete ms;
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Import1Click(TObject *Sender)
{
 if(!open) return;
 if(OpenDialogImport->Execute()){
    TMemoryStream* ms=new TMemoryStream;
    ms->LoadFromFile(OpenDialogImport->FileName);
    ms->Read(&smc.level,sizeof(TLevel));
    delete ms;
    smc.curr_rm=smc.level.start_rm;
    DrawRoom();
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Automatic1Click(TObject *Sender)
{
 Automatic1->Checked=true;
 amode=true;
 //ComboBoxTile->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Manual1Click(TObject *Sender)
{
 Manual1->Checked=true;
 amode=false;
 //ComboBoxTile->Enabled=true;
}
//---------------------------------------------------------------------------

void TMainForm::DoAuto(int what){
   unsigned char fg1=ComboBoxFg->ItemIndex,gg1=ComboBoxGg->ItemIndex,
      ob1=ComboBoxOb->ItemIndex,fl1=0,fg,gg,ob,fl=0;
   int i,j,t,rm2,s,o; bool u[256];
   for(i=0;i</*8*/2;i++){
      if(CheckListBoxFlags->Checked[i]) fl1|=1<<i;
   }
   for(i=0;i<3;i++) for(j=0;j<10;j++) if(smc.sel[i][j]){
      t=smc.level.fg[smc.curr_rm][i][j];
      fg=smc.level.block_fg[t];
      gg=smc.level.block_gg[t];
      ob=smc.level.block_ob[t];
      //fl=smc.level.block_fl[t];
      fl=smc.get_block_fl(t);
      switch(what){
         case 'f': fg=fg1; break;
         case 'g': gg=gg1; break;
         case 'o': ob=ob1; break;
         case 'F': fl=fl1; break;
      }
      smc.level.fg[smc.curr_rm][i][j]=0;
      for(t=0;t<256;t++){
         if(smc.level.block_fg[t]==fg&&smc.level.block_gg[t]==gg&&
            smc.level.block_ob[t]==ob&&/*smc.level.block_fl[t]*/smc.get_block_fl(t)==fl) break;
      }
      if(t<256){
         smc.level.fg[smc.curr_rm][i][j]=t;
      }else{
         for(t=0;t<256;t++) u[t]=false;
         for(rm2=0;rm2<24;rm2++) for(s=0;s<3;s++) for(o=0;o<10;o++) u[smc.level.fg[rm2][s][o]]=true;
         for(t=1;t<255;t++) if(!u[t]) break;
         if(t<255){
            smc.level.block_fg[t]=fg;
            smc.level.block_gg[t]=gg;
            smc.level.block_ob[t]=ob;
            //smc.level.block_fl[t]=fl;
            smc.set_block_fl(t,fl);
            smc.level.fg[smc.curr_rm][i][j]=t;
         }else{
            ShowMessage("No room for tile!");
         }
      }
   }
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Labels1Click(TObject *Sender)
{
   Labels1->Checked=smc.want_label=!smc.want_label;
   if(!open) return;
   DrawRoom();
   ComboBoxTile->Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Clearallroomsandtiles1Click(TObject *Sender)
{
 if(Application->MessageBox("Do you really want to clear all rooms and tiles?","Clear all rooms and tiles",MB_YESNO)==IDYES){
    ClearAll(true);
    DrawRoom();
 }
}
//---------------------------------------------------------------------------

void TMainForm::ClearAll(bool tiles){
#define fill(what,byte) memset(&what,byte,sizeof(what))
/*    memset(&smc.level,0,sizeof(smc.level));
    memset(&smc.level.door1,255,sizeof(smc.level.door1));
    memset(&smc.level.door2,255,sizeof(smc.level.door2));
    memset(&smc.level.rm_links,255,sizeof(smc.level.rm_links));
    memset(&smc.level.guard_ps,255,sizeof(smc.level.guard_ps));*/
    if(tiles){
       fill(smc.level.block_gg,0);
       fill(smc.level.block_fg,0);
       fill(smc.level.block_ob,0);
       fill(smc.level.block_fl,0);
    }
    fill(smc.level.bg,0);
    fill(smc.level.fg,0);
    fill(smc.level.md,0);
    fill(smc.level.rm_links,255);
    smc.level.start_rm=0;
    smc.level.start_ps=0;
    smc.level.start_dr=0;
    smc.level.zero=0;
    fill(smc.level.guard_ps,255);
    fill(smc.level.guard_tp,0);
    fill(smc.level.guard_sk,0);
    fill(smc.level.guard_uk1,0);
    fill(smc.level.guard_uk2,0);
    fill(smc.level.guard_uk3,0);
    fill(smc.level.door1,255);
    fill(smc.level.door2,255);
#undef fill
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Clearallrooms1Click(TObject *Sender)
{
 if(Application->MessageBox("Do you really want to clear all rooms?","Clear all rooms",MB_YESNO)==IDYES){
    ClearAll(false);
    DrawRoom();
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Clearthisroom1Click(TObject *Sender)
{
 if(Application->MessageBox("Do you really want to clear this room?","Clear this room",MB_YESNO)==IDYES){
    memset(&smc.level.bg[smc.curr_rm],0,sizeof(smc.level.bg[smc.curr_rm]));
    memset(&smc.level.fg[smc.curr_rm],0,sizeof(smc.level.fg[smc.curr_rm]));
    memset(&smc.level.md[smc.curr_rm],0,sizeof(smc.level.md[smc.curr_rm]));
    DrawRoom();
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Jumptoroom1Click(TObject *Sender)
{
// AnsiString s=IntToStr(rm);
 int rm2=smc.curr_rm;
/* s=InputBox("Which room do you want to jump to? (0-23)","Jump to room",s);
 try{
    rm2=StrToInt(s);
 }catch(...){
    //
 }*/
 rm2=InputNum("Jump to room","Which room do you want to jump to? (0-23)",smc.curr_rm);
 if(rm2>=0 && rm2<=23){
    smc.curr_rm=rm2;
    DrawRoom();
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Changetype1Click(TObject *Sender)
{
 int lt=Select(ltypes,COUNT(ltypes),smc.ltype,"Change level type");
 //*((char*)smc.ms_smc->Memory+0x36EE+SMCHD+level)=smc.ltype=lt;
 smc.set_ltype(smc.curr_level,lt);
 DrawRoom();
}
//---------------------------------------------------------------------------

void TMainForm::RealignStuff()
{
   //Doublesize1->Checked=!Doublesize1->Checked;
   //scale=Doublesize1->Checked?2:1;
   PaintBox1->OnPaint(NULL);
   ButtonUp->Top = Panel1->Top + Panel1->Height - 2;
   //PaintBox1->Top=ButtonUp->Top+ButtonUp->Height;
   ButtonUp->Left=PaintBox1->Left+PaintBox1->Width/2-ButtonUp->Width/2;
   ButtonLeft->Top=PaintBox1->Top+PaintBox1->Height/2-ButtonUp->Height/2;
   ButtonDown->Left=PaintBox1->Left+PaintBox1->Width/2-ButtonUp->Width/2;
   ButtonRight->Top=PaintBox1->Top+PaintBox1->Height/2-ButtonUp->Height/2;
   ButtonRight->Left=PaintBox1->Left+PaintBox1->Width+20;
   ButtonDown->Top=PaintBox1->Top+PaintBox1->Height+0;
   PlaceSidebtn();
}
//---------------------------------------------------------------------------

void TMainForm::PlaceSidebtn(){
   int i;
   AnsiString s;
   for(i=0;i<10;i++){
      sidebtn[i]->Width=PaintBox1->Width/10;
      sidebtn[i]->Height=16;
      sidebtn[i]->Left=PaintBox1->Left+i*PaintBox1->Width/10;
      sidebtn[i]->Top=PaintBox1->Top-sidebtn[i]->Height;
      s.printf("C%d",i);
      sidebtn[i]->Caption=s;
      sidebtn[i]->Hint="Select this column";
   }
   for(i=0;i<3;i++){
      sidebtn[i+10]->Width=16;
      sidebtn[i+10]->Height=PaintBox1->Height/3;
      sidebtn[i+10]->Left=PaintBox1->Left-sidebtn[i+10]->Width;
      sidebtn[i+10]->Top=PaintBox1->Top+i*PaintBox1->Height/3;
      s.printf("L%d",i);
      sidebtn[i+10]->Caption=s;
      sidebtn[i+10]->Hint="Select this line";
   }
   sidebtn[13]->Width=16;
   sidebtn[13]->Height=16;
   sidebtn[13]->Left=PaintBox1->Left-sidebtn[13]->Width;
   sidebtn[13]->Top=PaintBox1->Top-sidebtn[13]->Height;
   sidebtn[13]->Caption="all";
   sidebtn[13]->Hint="Select whole room";
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
 int i;
 for(i=0;i<14;i++){
    delete (sidebtn[i]); // Doesn't work in FormDestroy
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SideClick(TObject *Sender){
   if(!open) return;
   int tag=((TButton*)Sender)->Tag,i,j;
   if(!(GetAsyncKeyState(VK_CONTROL)&0x80000000)) smc.clearsel();
   if(tag>=0 && tag<=9){
      j=tag;
      for(i=0;i<3;i++) smc.sel[i][j]=true;
   }
   if(tag>=10 && tag<=12){
      i=tag-10;
      for(j=0;j<10;j++) smc.sel[i][j]=true;
   }
   if(tag==13){
      for(i=0;i<3;i++) for(j=0;j<10;j++) smc.sel[i][j]=true;
   }
   DrawRoom();
}
//---------------------------------------------------------------------------

int InputNum(AnsiString Caption,AnsiString Prompt,int Default){
   int x=Default;
   AnsiString s=InputBox(Caption,Prompt,IntToStr(x));
   try{x=StrToInt(s);}catch(...){}
   return x;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Hitpoints1Click(TObject *Sender)
{
   if(!open) return;
   AnsiString p;
   int tp=smc.level.guard_tp[smc.curr_rm]&0x7F;
   unsigned char* ad=(unsigned char*)smc.getaddr(0x80A5+tp);
   p.printf("The number of hitpoints for all \"%s\" guards in the game:",gu[tp]);
   int x=*ad;
   x=InputNum("Guard hitpoints",p,x);
   *ad=x;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Palettes1Click(TObject *Sender)
{
   if(!open) return;
   AnsiString p;
   int tp=smc.level.guard_tp[smc.curr_rm]&0x7F;
   unsigned char* ad=(unsigned char*)smc.getaddr(0x759E+tp);
   p.printf("The palette for all \"%s\" guards in the game:",gu[tp]);
   int x=*ad;
   x=InputNum("Guard palettes",p,x);
   *ad=x;
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Settings1Click(TObject *Sender)
{
 static const char* names[]={"fat","normal guard","shadow (prince)","skeleton","knight","jaffar","girl","monster"};
 static const int sprites[]={212,244,276,308,340,372,936,988};
 static const int swords[]={3,4,5,6,7,10,4,4};
 static const char* props[]={"strike probability","restrike probability","block probability","impblockprob","advance probability","refractory timer","?","hit points","palette","sprite"};
 TForm* dform;
 TLabel**dlabel; TEdit**dedit; TComboBox*dcombo; TButton*dok,*dcan;
 int i;
 int tp=smc.level.guard_tp[smc.curr_rm]&0x7F;
 if(smc.level.guard_ps[smc.curr_rm]>=30 || tp<2 || tp>19){
    ShowMessage("There is no guard in this room!");
    return;
 }
 AnsiString s;
 dform=new TForm(Application);
 dform->Position=poMainFormCenter;
 dform->Height=12*30;
// dform->Caption="Guard Settings";
 s.printf("Guard settings for all \"%s\" guards in the game:",gu[tp]);
 dform->Caption=s;
 dform->BorderIcons=TBorderIcons();
 dform->BorderStyle=bsSingle;
 dok=new TButton(Application);
 dok->Parent=dform;
 dok->Caption="OK";
 dok->Left=100;
 dok->Top=10*30;
 dok->Default=true;
 dok->ModalResult=mrOk;
 dcan=new TButton(Application);
 dcan->Parent=dform;
 dcan->Caption="Cancel";
 dcan->Left=200;
 dcan->Top=10*30;
 dcan->Cancel=true;
 dcan->ModalResult=mrCancel;
 dlabel=new TLabel*[10];
 for(i=0;i<10;i++){
    dlabel[i]=new TLabel(Application);
    dlabel[i]->Parent=dform;
    dlabel[i]->Caption=props[i];
    dlabel[i]->Left=25;
    dlabel[i]->Top=i*30+5;
 }
 dedit=new TEdit*[9];
 for(i=0;i<9;i++){
    dedit[i]=new TEdit(Application);
    dedit[i]->Parent=dform;
    dedit[i]->Left=125;
    dedit[i]->Top=i*30+5;
 }
 dcombo=new TComboBox(Application);
 dcombo->Parent=dform;
 dcombo->Left=125;
 dcombo->Top=9*30+5;
 dcombo->Style=csDropDownList;
 for(i=0;i<COUNT(names);i++){
    dcombo->Items->Add(names[i]);
 }
 for(i=0;i<8;i++){
    dedit[i]->Text=IntToStr(*(unsigned char*)smc.getaddr(0x8022-2+i*19+tp));
 }
 dedit[8]->Text=IntToStr(*(unsigned char*)smc.getaddr(0x759E+tp));
 int spr=*(unsigned __int16*)smc.getaddr(0xBF80+(tp<<1));
 for(i=0;i<COUNT(sprites);i++){
    if(sprites[i]==spr) dcombo->ItemIndex=i;
 }
 if(dform->ShowModal()==mrOk){
    for(i=0;i<8;i++){
       *(unsigned char*)smc.getaddr(0x8022-2+i*19+tp)=StrToInt(dedit[i]->Text);
    }
    *(unsigned char*)smc.getaddr(0x759E+tp)=StrToInt(dedit[8]->Text);
    spr=dcombo->ItemIndex;
    *(unsigned __int16*)smc.getaddr(0xBF80+(tp<<1))=sprites[spr];
    *(unsigned char*)smc.getaddr(0xC1C6-2+tp)=swords[spr];
    DrawRoom();
 }
 delete dcombo;
 for(i=0;i<10;i++) delete dlabel[i];
 delete[]dlabel;
 for(i=0;i<9;i++) delete dedit[i];
 delete[]dedit;
 delete dok; delete dcan;
 delete dform;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Changemusic1Click(TObject *Sender)
{
   AnsiString p;
   unsigned char* ad=(unsigned char*)smc.getaddr(0x1145C+smc.curr_level);
   int x=*ad;
   x=InputNum("Level music","Music for current level (255 for none)",x);
   *ad=x;
   //DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Editenvpal1Click(TObject *Sender)
{
   if(!open) return;
 smc.editenvpal();
 RedrawAll();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Editspritespal1Click(TObject *Sender)
{
   if(!open) return;
 smc.editspritespal();
 RedrawAll();
}
//---------------------------------------------------------------------------
void TMainForm::RedrawAll(){
 DrawRoom();
 this->Refresh();
 ComboBoxBack->Refresh();
 ComboBoxFg->Refresh();
 ComboBoxGg->Refresh();
 ComboBoxTile->Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Layer1Click(TObject *Sender)
{
   if(!open) return;
   smc.editlevelgr(1);
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Layer2Click(TObject *Sender)
{
   if(!open) return;
   smc.editlevelgr(2);
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Layer3Click(TObject *Sender)
{
   if(!open) return;
   smc.editlevelgr(3);
   DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::EditAnimGroupChange(TObject *Sender)
{
   int bg=ComboBoxBack->ItemIndex;
   try{
      int anim=StrToInt(EditAnimGroup->Text);
      smc.set_bganim(bg,anim);
   }catch(...){
      EditAnimGroup->Text=IntToStr(smc.get_bganim(bg));
   }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::N1x1Click(TObject *Sender)
{
   scale = 1;
   RealignStuff();
   N1x1->Checked = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::N2x1Click(TObject *Sender)
{
   scale = 2;
   RealignStuff();
   N2x1->Checked = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::N3x1Click(TObject *Sender)
{
   scale = 3;
   RealignStuff();
   N3x1->Checked = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::N4x1Click(TObject *Sender)
{
   scale = 4;
   RealignStuff();
   N4x1->Checked = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Swappositions1Click(TObject *Sender)
{
 int rm2=smc.curr_rm;
 rm2=InputNum("Swap room positions","Swap positions of current room with which room? (0-23)",smc.curr_rm);
 if(rm2>=0 && rm2<=23){
    smc.swap_room_positions(smc.curr_rm,rm2);
    DrawRoom();
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Swapdetails1Click(TObject *Sender)
{
 int rm2=smc.curr_rm;
 rm2=InputNum("Swap room details","Swap details of current room with which room? (0-23)",smc.curr_rm);
 if(rm2>=0 && rm2<=23){
    smc.swap_room_details(smc.curr_rm,rm2);
    DrawRoom();
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Swaptransparent1Click(TObject *Sender)
{
 int rm2=smc.curr_rm;
 rm2=InputNum("Swap room transparently","Swap current room with which room? (0-23)",smc.curr_rm);
 if(rm2>=0 && rm2<=23){
    smc.swap_room_transparent(smc.curr_rm,rm2);
    DrawRoom();
 }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Copyroom1Click(TObject *Sender)
{
 //TClipboard* clipboard = Clipboard();
 //TMemoryStream* ms_room = new TMemoryStream();
 //clipboard->Assign(ms_room);
 //delete ms_room;
 int room = smc.curr_rm;
 memcpy(room_clipboard.bg, smc.level.bg[room], 30);
 memcpy(room_clipboard.fg, smc.level.fg[room], 30);
 memcpy(room_clipboard.md, smc.level.md[room], 30);
 room_clipboard.guard_ps = smc.level.guard_ps[room];
 room_clipboard.guard_tp = smc.level.guard_tp[room];
 room_clipboard.guard_sk = smc.level.guard_sk[room];
 room_clipboard.guard_uk1 = smc.level.guard_uk1[room];
 room_clipboard.guard_uk2 = smc.level.guard_uk2[room];
 room_clipboard.guard_uk3 = smc.level.guard_uk3[room];
 room_clipboard_notempty = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Pasteroom1Click(TObject *Sender)
{
 //TClipboard* clipboard = Clipboard();
 //if (clipboard->HasFormat(CF_TEXT)) {
 //   TMemoryStream* ms_room = new TMemoryStream();
 //   //ms_room-> ;
 //   delete ms_room;
 //}
 if (! room_clipboard_notempty) {
    return;
 }
 if (Application->MessageBox("Overwrite this room?","Paste",MB_YESNO) != IDYES) {
    return;
 }
 int room = smc.curr_rm;
 memcpy(smc.level.bg[room], room_clipboard.bg, 30);
 memcpy(smc.level.fg[room], room_clipboard.fg, 30);
 memcpy(smc.level.md[room], room_clipboard.md, 30);
 smc.level.guard_ps[room] = room_clipboard.guard_ps;
 smc.level.guard_tp[room] = room_clipboard.guard_tp;
 smc.level.guard_sk[room] = room_clipboard.guard_sk;
 smc.level.guard_uk1[room] = room_clipboard.guard_uk1;
 smc.level.guard_uk2[room] = room_clipboard.guard_uk2;
 smc.level.guard_uk3[room] = room_clipboard.guard_uk3;
 DrawRoom();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Floorsandwalls1Click(TObject *Sender)
{
   if (!open) return;
   Floorsandwalls1->Checked = smc.want_floors_walls = !smc.want_floors_walls;
   DrawRoom();
   ComboBoxTile->Refresh();
}
//---------------------------------------------------------------------------

